<template>
    <v-card class="interview-card mb-3">
        
        <v-card-title>
            <v-layout row>
                <v-flex xs2 sm1>
                    <v-icon :color="typeColor">{{typeIcon}}</v-icon>
                </v-flex>
                <v-flex xs9 sm10 class="title">
                    <div style="height: 100%;  display: flex; flex-direction: column; justify-content: center;">
                    <div>
                        {{header}}
                    </div>
                    </div>
                </v-flex>
                <v-flex xs1>
                    <v-icon  :color="doneColor" @click="markDone" style="font-weight: 900 !important">check</v-icon>                
                </v-flex>
            </v-layout>
        </v-card-title>
        
        <v-divider />
        
        <v-card-text class="mb-0 pb-0">
            <v-container fluid grid-list-xs>
                    <v-layout row wrap class="body-1">
                        <v-flex xs2 class="table-header">{{$i18n.t("interview.details.when")}}</v-flex>
                        <v-flex xs10 style="padding-left: 8px;">
                              <v-dialog
                                v-model="dateDialog"
                                lazy 
                                full-width
                                width="290px">
                                <v-date-picker v-if="dateDialog" scrollable @input="setDate"></v-date-picker>
                            </v-dialog>
                             <v-dialog
                                v-model="timeDialog"
                                lazy
                                full-width
                                width="290px">
                                <v-time-picker v-if="timeDialog" format="24hr" @input="setTime"></v-time-picker>
                             </v-dialog>
                            <span class="editable textfield" v-text="interviewDate" @click="dateDialog = true"></span>, 
                            <span class="editable textfield" v-text="interviewTime" @click="timeDialog = true"></span>
                        </v-flex>
                        
                        <v-flex xs2 class="table-header" v-if="root.type=='ON_SITE'" >{{$i18n.t("interview.details.where")}}</v-flex>
                        <v-flex xs10 v-if="root.type=='ON_SITE'" style="padding-left: 8px;">
                            <div :class="root.location ? '' : 'empty-note'" 
                                v-if="!edit.location" 
                                class="editable" 
                                v-html="location" 
                                style="white-space: pre-line;"
                                @click="startEdit('location')"></div>
                            <v-textarea style="padding-left: 4px;"
                                v-if="!!edit.location"
                                @blur="endEdit('location')" 
                                @keydown.ctrl.enter="endEdit('location')" 
                                @keydown.esc="cancelEdit('location')" 
                                autofocus
                                browser-autocomplete='off' 
                                rows="1" 
                                auto-grow 
                                v-model="root.location"></v-textarea>
                        </v-flex>
                        
                        <v-flex xs2 class="table-header" style="height: 48px;">
                              <div style="height: 100%;  display: flex; flex-direction: column; justify-content: center;">
                                <div>{{$i18n.t("interview.details.who")}}</div>
                              </div>
                        </v-flex>
                        <v-flex xs10>
                            <div v-if="!hasInterviewers" style="height: 100%; display: flex; flex-direction: column; justify-content: center;">
                                <div :class="this.$vuetify.breakpoint.smAndUp ? 'pl-1' : ''" >{{$i18n.t("interview.details.noInterviewer")}}</div>
                            </div>
                            <div v-if="hasInterviewers" class="mt-1">
                                <v-chip color="primary" disabled outline 
                                    :key="value"
                                    v-for="(value) in interview.interviewers" >
                                    <v-avatar>
                                      <v-icon>account_circle</v-icon>
                                    </v-avatar>
                                    <div>
                                      {{value}}
                                    </div>
                                </v-chip> 
                            </div>
                        </v-flex>
                        
                        <v-flex xs2 class="table-header">{{$i18n.t("interview.details.note")}}</v-flex>
                        <v-flex xs10 style="padding-left: 8px;">
                            <div :class="root.description ? '' : 'empty-note'" 
                                v-if="!edit.note" 
                                class="editable" 
                                v-html="description" 
                                style="white-space: pre-line;"
                                @click="startEdit('note')"></div>
                            <v-textarea style="padding-left: 4px;"
                                    v-if="!!edit.note"
                                    @blur="endEdit('note')" 
                                    @keydown.ctrl.enter="endEdit('note')" 
                                    @keydown.esc="cancelEdit('note')" 
                                    autofocus
                                    browser-autocomplete='off' 
                                    rows="1" 
                                    auto-grow 
                                    v-model="root.description"></v-textarea>
                        </v-flex>
                        
              </v-layout>
            </v-container>
        </v-card-text>
        <v-divider light></v-divider>
        <v-card-actions right>
            <v-spacer/>
            <v-btn flat small icon @click="editInterview"><v-icon small>edit</v-icon></v-btn>
            <v-btn flat small icon @click="$emit('delete')"><v-icon small>delete</v-icon></v-btn>
        </v-card-actions>
        
        <v-layout row justify-center>
            <v-dialog v-model="editDialog" persistent fullscreen hide-overlay transition="dialog-bottom-transition">
                <InterviewForm @cancel="closeDialog" mode="edit" :item="root" @save="save"/>
            </v-dialog>
        </v-layout>
    </v-card>
</template>

<script>
import InterviewForm from '../forms/InterviewForm'  
import moment from 'moment'
export default {
  name: 'InterviewCard',
  props: ['interview', 'application'],
  components: { InterviewForm },
  data() {
    return { 
        edit: {
            note: null,
            location: null
        },
        root: this.interview,
        timeDialog: null,
        dateDialog: null,
        editDialog: null,
        original: null
    }
  },
  methods: {
    closeDialog() {
        this.root = Object.assign({}, this.original)
        this.original = null
        this.editDialog = false
    },
    editInterview() {
        this.original = Object.assign({}, this.root)
        this.editDialog = true
    },
    async markDone() {
        this.root.done = typeof this.root.done == 'boolean' ? !this.root.done : true
        await this.$api.updateInterview(this.application.id, Object.assign({ }, this.root))
    },
    async setTime(event) {
        const time = moment(event, "HH:mm")
        this.root.date = moment(this.root.date)
            .hour(time.hour())
            .minutes(time.minutes()).toDate()
        this.timeDialog = false
        await this.$api.updateInterview(this.application.id, Object.assign({ }, this.root))
    },
    async setDate(event) {
        const date = moment(event, "YYYY-MM-DD")
        this.root.date = moment(this.root.date)
            .year(date.year())
            .month(date.month())
            .date(date.date()).toDate()
        this.dateDialog = false
        await this.$api.updateInterview(this.application.id, Object.assign({ }, this.root))
    },
    startEdit(field) {
        this.edit[field] = true
    },
    cancelEdit(field) {
        this.edit[field] = false
    },
    async endEdit(field) {
        try {
            this.edit[field] = false
            await this.$api.updateInterview(this.application.id, this.root)
        }
        catch ( e ) {
            this.$logger.error("Error while saving interview", e.message)
        }
    },
    async save(interview) {
        this.root = Object.assign({}, interview)
        this.editDialog = false
        await this.$api.updateInterview(this.application.id, this.root)
    }
  },
  computed: {
    rightCellPadding() {
        return this.$vuetify.breakpoint.smAndUp ? 'pl-2' : '' 
    },
    
    doneColor() {
        return this.root.done ? 'green darken-3' : '#ccc'
    },
    header() {
        const type = this.root.type || 'default';
        return this.$i18n.t(`interview.type.${type.toLowerCase()}`)
    },
    
    interviewTime() {
        return moment(this.root.date).format(this.$i18n.t("interview.format.time"))
    },
    interviewDate() {
        return moment(this.root.date).format(this.$i18n.t("interview.format.date"))
    },
    
    hasInterviewers() {
        return this.root.interviewers && this.root.interviewers.length > 0
    },
    
    location() {
        const location = this.root.location;
        return location ? location : 'Click to set location...'
    },
    description: {
        get() {
            return this.root.description || this.$i18n.t("interview.actions.annotate.description")
        },
        set(d) {
            this.root.description = d
        }
    },
    
    typeIcon() {
        switch (this.root.type) {
          case 'PHONE': return 'phone_in_talk';
          case 'ON_SITE': return 'location_on';
          case 'SCREENING': return 'contact_phone'; 
          case 'VIDEO_CALL': return 'videocam';
          default: return 'contact_support'
        }
    },
    typeColor() {
        switch (this.root.type) {
          case 'PHONE': return 'green';
          case 'ON_SITE': return 'red';
          case 'SCREENING': return '#666'; 
          case 'VIDEO_CALL': return 'primary';
          default: return '#aaa'
        }
    }
  }
}
</script>

<style>
.table-header {
    color: #999;
}
.empty-note {
  color: #aaa;
}
.interview-card {
  cursor: default !important;
}
.textfield.editable {
  border-bottom: 1px dotted #ccc;
}
</style>

